<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>WEB COMPONENTS</title>
    <link rel="stylesheet" href="./style.css" />
    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC"
      crossorigin="anonymous"
    />
  </head>
  <body>
    <div class="area">
      <!-- number is an atribute in this component. in js property  -->
      <h1
        class="card text-center"
        style="padding: 30px; letter-spacing: 0.8rem; color: #4e54c8"
      >
        WEB COMPONENTS:
      </h1>
      <h3 class="alert alert-primary" role="alert">Custom tag:</h3>
      <li>
        We can create our own tags with original logic inside. We can also style
        this custom element as we want to.
      </li>
      <li>
        To create our own custom element we have to write our Class which
        extends it to HTMLElement.
      </li>
      <li>
        We are using our own custom tag like the other ones. The same system as
        with: div's, p's, span's etc..
      </li>
      <li>
        To proper name the custom tag use dash(-) beetween words ex: "tom-tag"
      </li>
      <li>You can create only one tag with same name ex: only one "tom-tag"</li>
      <li>
        to check custom element's docs try:
        <b
          >https://developer.mozilla.org/en-US/docs/Web/Web_Components/Using_custom_elements</b
        >
      </li>
      <hr />
      <h3 class="alert alert-primary">Custom tag example:</h3>
      <web-comp id="numb" number="10"></web-comp>
      <button type="button" class="btn btn-primary" id="butt" onclick="count()">
        Update
      </button>
      <hr />
      <h3 class="alert alert-info" role="alert">Shadow DOM:</h3>
      <li>We can isolate (encapsulate) created element from the DOM tree.</li>
      <li>What's going on in the shadow DOM stays in shadow DOM.</li>
      <li>
        <b>How to create this custom element:</b>
        <ul>
          <li>We have to define Class which extends to HTML element</li>
          <li>
            We have to create our shadow root to make our styles are independent
            form the others
          </li>
        </ul>
      </li>
      <hr />
      <h3 class="alert alert-danger" style="color: #4e54c8" role="alert">
        How to move in the DOM:
      </h3>
      <button type="button" class="btn btn-info" onclick="dom1()">1</button>
      <p>
        To see all the nodes from your document use command:
        <b>"document.body.childNodes"</b> .
        <li>Each of the nodes are objects.</li>
        <li>ChildNodes - nodelist displays all of the node of the DOM.</li>
        <li>Children - is a nodelist filtered by type of the element</li>
        <li>
          If you want to get for example 4-th button from nodelist you have to
          use <b>"document.body.querySelectorAll('button').[4]"</b> command.
        </li>
        <li>
          If you want to get 3-th list and dispaly the text of it you have to
          use
          <b>"document.body.querySelectorAll('li')[3].innerHTML"</b>
        </li>
        <li>Parent node - parentNode checks node which is above</li>
      </p>
      <hr />
      <button type="button" class="btn btn-info" onclick="dom2()">2</button>
      <p>
        Check the node types. There's 12 node types in DOM. Here's the most
        important ones:
      </p>
      <li>1. Element - An Element like div or p or span</li>
      <li>2. Atribute - An Atribute of an Element</li>
      <li>3. Text - The acctual Text inside an Element of Attr</li>
      <li>8. Comment - represents a comment</li>
      <li>
        9. Document - represents the entire document (the root-node of the DOM
        tree)
      </li>
      <hr />
      <h1
        class="card text-center"
        style="padding: 30px; letter-spacing: 0.8rem; color: #4e54c8"
      >
        DOM EVENTS:
      </h1>
      <br />
      <li>
        <b>addEventListener()</b>
        <ul>
          <div style="color: green"><b>PROS</b></div>
          <li>You can attach multiple events to this method</li>
          <li>
            You can use removeEventListener() to remove some event previously
            defined
          </li>
          <li>You can add event bubbling as third function parameter</li>
          <li>
            You can use preventDefault() to stop executing the deafult function
            flow =>
            <a href="http://google.com" style="color: white"> CLICK LINK</a>
          </li>
          <li>
            Go to the url ("window.location.replace()") <br />
            <button class="btn-info" id="goto">Go to url</button>
          </li>
        </ul>
      </li>
      <li>
        <b> onclick() </b>
        <ul>
          <div style="color: red"><b>CONS</b></div>
          <li>onclick() is mixing JS code with HTML</li>
          <li>You can attach just only one event to this method</li>
        </ul>
      </li>
      <h3 class="alert alert-primary">Event bubbling:</h3>

      <li>
        Capturing(propagation) phase:
        <button class="btn btn-primary" onclick="showcapturing()">
          Show capturing phase
        </button>
      </li>
      <ul>
        <li>
          Capturing is goes from box(1) => target element box(4); from up to
          down or Window = > target
        </li>
      </ul>
      <li>
        Bubbling phase:
        <button class="btn btn-primary" onclick="showbubbling()">
          Show bubbling phase
        </button>
      </li>
      <ul>
        <li>Bubbling returns from target to last element</li>
        <li>
          Bubbling goes from target element box (4) => box(1); from down to up
          or target => Window
        </li>
      </ul>

      <br /><br />
      <h5 class="alert alert-primary" style="color: #4e54c8">
        <b></b>
        <div class="box one">
          one
          <div class="box two">
            two
            <div class="box three">
              three
              <div class="box four">four</div>
            </div>
          </div>
        </div>
      </h5>
      <br />
      <h3 class="alert alert-primary">3 methods describtion:</h3>
      <h5 class="alert alert-primary" style="color: #4e54c8">
        <b>bind()</b>
        <button type="button" class="btn btn-primary" onclick="bindFc()">
          bind()
        </button>
        <br /><br />
        <p>
          You can use bind() when you want to add your function/method to a new
          variable. Instead of using square brackets you can use qoutation marks
          . To execute your binded function you have to write it's name under
          variable. Click it below and lauch DevTools to check how it work's:
        </p>
      </h5>
      <h5 class="alert alert-primary" style="color: #4e54c8">
        <b>call()</b> <br />
        <br />
        <p>
          You can use call() method to bring function/method from object and use
          that function as a way to display values from the other object. Click
          it below and lauch DevTools to check how it work's:
        </p>
        <button type="button" class="btn btn-primary" onclick="callFc()">
          call()
        </button>
        <button type="button" class="btn btn-primary" onclick="callFc2()">
          call()foreach
        </button>
      </h5>
      <h5 class="alert alert-primary" style="color: #4e54c8">
        <b>apply()</b> <br /><br />
        <p>
          You can apply new value to the previously defined variable. You can
          add addictional parameters to your function as well. Example below:
        </p>
        <button type="button" class="btn btn-primary" onclick="applyFc()">
          apply()
        </button>
      </h5>
      <br />

      <div class="circles">
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
        <li></li>
      </div>
    </div>
    <script src="./app.js"></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
      crossorigin="anonymous"
    ></script>
  </body>
</html>
